' Mini-Designer: der absolut einfachste Designer ohne Schnrkel
' (c) 2001 by Andreas Meile, CH-8242 Hofen SH
' e-Mail: andreas@hofen.ch  WWW: http://www.hofen.ch/~andreas/
' Demonstriert ein ganz einfaches Vektorzeichenprogramm, welches den
' Komfort von CorelDRAW!, Adobe Illustrator und Micrografx Designer
' sowie WinWord-Grafikeditor bietet :-)

' Kommandos:
' - Zeichnen von Linien, Kreis (Ellipse) und Rechteck
' - Objektauswahl => Bearbeitungsoperationen
' - Kopieren und Verschieben mglich: Wie im Word-Grafikeditor
'   einfach die Ctrl-Taste whrend dem Mausklick gedrckt halten,
'   wenn man kopieren statt verschieben will
' - Lschen: <Del>-Taste wie in CorelDRAW!
' - Dazuwhlen/Wegwhlen: Ebenfalls wie in CorelDRAW! einfach Umschalttaste
'   whrend Mausklick gedrckt halten

' Grenzen:
' - QB bietet kein XOR-Zeichenmodus => deswegen wird der Bildschirm ziemlich
'   rasch "verschmiert" => "Neuzeich" anklicken, um Bild neu aufbauen
'   Einzige Mglichkeit: XOR-Rechtecke mittels PUT-Trick (nur Farbe 15)

' $INCLUDE: 'qb.bi'

TYPE Linie
	x1 AS INTEGER
	y1 AS INTEGER
	x2 AS INTEGER
	y2 AS INTEGER
	fa AS INTEGER
	gew AS INTEGER
END TYPE

TYPE Rechteck
	x1 AS INTEGER
	y1 AS INTEGER
	x2 AS INTEGER
	y2 AS INTEGER
	fa AS INTEGER
	gew AS INTEGER
END TYPE

TYPE Kreis
	xm AS INTEGER
	ym AS INTEGER
	rx AS INTEGER
	ry AS INTEGER
	fa AS INTEGER
	gew AS INTEGER
END TYPE

DECLARE SUB MarkiereMenu (i%, t%)
DECLARE SUB ZeichneLinie (l AS Linie, f%)
DECLARE SUB ZeichneRechteck (r AS Rechteck, f%)
DECLARE SUB ZeichneKreis (k AS Kreis, f%)
DECLARE SUB NeuzeichAlles ()
DECLARE SUB RechteckXOR (x1%, y1%, x2%, y2%, f%)
DECLARE SUB MarkiereGewaehltLinie (l AS Linie)
DECLARE SUB MarkiereGewaehltRechteck (r AS Rechteck)
DECLARE SUB MarkiereGewaehltKreis (k AS Kreis)
DECLARE SUB ZeichneMausgriffchen (x1%, y1%, x2%, y2%)
DECLARE SUB LoescheAuswahl (f%)
DECLARE SUB TransformiereLinie (lAlt AS Linie, lNeu AS Linie)
DECLARE SUB TransformiereRechteck (rAlt AS Rechteck, rNeu AS Rechteck)
DECLARE SUB TransformiereKreis (kAlt AS Kreis, kNeu AS Kreis)

DIM SHARED li(1000) AS Linie, kr(1000) AS Kreis, re(1000) AS Rechteck
DIM SHARED aLi%, aKr%, aRe%, Fkt%, Farbe%, xorLin%(961)
DIM SHARED xMin%, yMin%, xMax%, yMax%, xMinA%, xMaxA%, yMinA%, yMaxA%
DIM SHARED xMinB%, xMaxB%, yMinB%, yMaxB%
DIM SHARED xFakt!, yFakt!, xTr!, yTr!

aLi% = 0: aKr% = 0: aRe% = 0

ZiehMod% = 0

FOR i% = 2 TO 961
	xorLin%(i%) = -1
NEXT i%

DIM dosIntEin AS RegTypeX, dosIntAus AS RegTypeX

SCREEN 12
MPunkte:
DATA "Whlen", "Linie", "Rechteck", "Kreis", "Neuzeich", "Ende"

xMin% = 10: xMax% = -10
LoescheAuswahl -1
Fkt% = 0
Farbe% = 9
NeuzeichAlles

dosIntEin.ax = 0
CALL INTERRUPTX(&H33, dosIntEin, dosIntAus)
IF dosIntAus.ax <> &HFFFF THEN
	PRINT "Keine Maus installiert!"
	END
END IF

dosIntEin.ax = 1
CALL INTERRUPTX(&H33, dosIntEin, dosIntAus)
Drinbleib% = -1
WHILE Drinbleib%
	dosIntEin.ax = 5
	dosIntEin.bx = 0
	CALL INTERRUPTX(&H33, dosIntEin, dosIntAus)
	IF dosIntAus.bx > 0 THEN
		x% = dosIntAus.cx
		y% = dosIntAus.dx
		dosIntEin.ax = 2
		CALL INTERRUPTX(&H33, dosIntEin, dosIntAus)
		mp% = -1
		IF x% > 556 AND x% < 627 THEN
			FOR i% = 0 TO 12
				IF y% > 12 + 32 * i% AND y% < 35 + 32 * i% THEN
					mp% = i%
				END IF
			NEXT i%
		END IF
		IF mp% > 5 THEN
			MarkiereMenu Farbe% - 3, 0
			MarkiereMenu mp%, -1
			Farbe% = mp% + 3
			IF xMax% > xMin% THEN
				LoescheAuswahl 0
				FOR i% = 0 TO aLi% - 1
					IF li(i%).gew THEN
						li(i%).fa = Farbe%
						ZeichneLinie li(i%), -1
					END IF
				NEXT i%
				FOR i% = 0 TO aRe% - 1
					IF re(i%).gew THEN
						re(i%).fa = Farbe%
						ZeichneRechteck re(i%), -1
					END IF
				NEXT i%
				FOR i% = 0 TO aKr% - 1
					IF kr(i%).gew THEN
						kr(i%).fa = Farbe%
						ZeichneKreis kr(i%), -1
					END IF
				NEXT i%
				ZeichneMausgriffchen xMin%, yMin%, xMax%, yMax%
			END IF
		ELSEIF mp% = 5 THEN
			Drinbleib% = 0
		ELSEIF mp% = 4 THEN
				NeuzeichAlles
		ELSEIF mp% >= 0 THEN
			IF xMax% >= xMin% THEN
				LoescheAuswahl -1
			END IF
			MarkiereMenu Fkt%, 0
			Fkt% = mp%
			MarkiereMenu mp%, -1
		ELSE
			' Abhngig von der Funktion!
			xAlt% = x%
			yAlt% = y%
			SELECT CASE Fkt%
			CASE 0
				' Mausgriffchen bettigt?
				IF x% >= xMin% AND x% <= xMax% AND y% >= yMin% AND y% <= yMax% THEN
					tLi% = x% < xMin% + 5
					tRe% = x% > xMax% - 5
					tOb% = y% < yMin% + 5
					tUn% = y% > yMax% - 5
					tLR% = tLi% OR tRe%
					tOU% = tOb% OR tUn%
					IF tLR% THEN
						IF tOU% THEN
							NurSchieb% = 0
						ELSE
							NurSchieb% = 2 * y% < yMax% + yMin% - 4 OR 2 * y% > yMax% + yMin% + 4
						END IF
						Waehlen% = 0
					ELSE
						IF tOU% THEN
							NurSchieb% = 2 * x% < xMax% + xMin% - 4 OR 2 * x% > xMax% + xMin% + 4
							Waehlen% = 0
						ELSE
							Waehlen% = -1
						END IF
					END IF
				ELSE
					Waehlen% = -1
				END IF
				IF Waehlen% THEN
					x1% = x%
					y1% = y%
					RechteckXOR x%, y%, x%, y%, 0
					ZiehMod% = 10
				ELSE
					' Drift ausrechnen
					xDr% = x% - xMin%
					yDr% = y% - yMin%
					' Temporre Kopie fr den Zugmodus
					zl% = aLi%
					FOR i% = 0 TO aLi% - 1
						IF li(i%).gew THEN
							MarkiereGewaehltLinie li(i%)
							li(zl%) = li(i%)
							li(zl%).gew = 0
							zl% = zl% + 1
						END IF
					NEXT i%
					zr% = aRe%
					FOR i% = 0 TO aRe% - 1
						IF re(i%).gew THEN
							MarkiereGewaehltRechteck re(i%)
							re(zr%) = re(i%)
							re(zr%).gew = 0
							zr% = zr% + 1
						END IF
					NEXT i%
					zk% = aKr%
					FOR i% = 0 TO aKr% - 1
						IF kr(i%).gew THEN
							MarkiereGewaehltKreis kr(i%)
							kr(zk%) = kr(i%)
							kr(zk%).gew = 0
							zk% = zk% + 1
						END IF
					NEXT i%
					xMinB% = xMin%
					xMaxB% = xMax%
					yMinB% = yMin%
					yMaxB% = yMax%
					ZiehMod% = 12
				END IF
			CASE 1
				li(aLi%).x1 = x%
				li(aLi%).y1 = y%
				li(aLi%).x2 = x%
				li(aLi%).y2 = y%
				li(aLi%).fa = Farbe%
				li(aLi%).gew = 0
				ZeichneLinie li(aLi%), -1
				ZiehMod% = 1
			CASE 2
				re(aRe%).x1 = x%
				re(aRe%).y1 = y%
				re(aRe%).x2 = x%
				re(aRe%).y2 = y%
				re(aRe%).fa = Farbe%
				re(aRe%).gew = 0
				ZeichneRechteck re(aRe%), -1
				ZiehMod% = 2
			CASE 3
				kr(aKr%).xm = x%
				kr(aKr%).ym = y%
				kr(aKr%).rx = 0
				kr(aKr%).rx = 0
				kr(aKr%).fa = Farbe%
				kr(aKr%).gew = 0
				x1% = x%
				y1% = y%
				ZeichneKreis kr(aKr%), -1
				ZiehMod% = 3
			END SELECT
		END IF
		dosIntEin.ax = 1
		CALL INTERRUPTX(&H33, dosIntEin, dosIntAus)
	END IF
	IF ZiehMod% > 0 THEN
		dosIntEin.ax = 3
		CALL INTERRUPTX(&H33, dosIntEin, dosIntAus)
		x% = dosIntAus.cx
		y% = dosIntAus.dx
		IF x% <> xAlt% OR y% <> yAlt% THEN
			dosIntEin.ax = 2
			CALL INTERRUPTX(&H33, dosIntEin, dosIntAus)
			SELECT CASE ZiehMod%
			CASE 1
				' Problem: Basic hat keinen XOR-Modus!!
				ZeichneLinie li(aLi%), 0
				li(aLi%).x2 = x%
				li(aLi%).y2 = y%
				ZeichneLinie li(aLi%), -1
			CASE 2
				ZeichneRechteck re(aRe%), 0
				re(aRe%).x2 = x%
				re(aRe%).y2 = y%
				ZeichneRechteck re(aRe%), -1
			CASE 3
				' Problem: Kein XOR-Modus!!
				ZeichneKreis kr(aKr%), 0
				kr(aKr%).xm = (x1% + x%) \ 2
				kr(aKr%).ym = (y1% + y%) \ 2
				kr(aKr%).rx = ABS(x% - x1%) \ 2
				kr(aKr%).ry = ABS(y% - y1%) \ 2
				ZeichneKreis kr(aKr%), -1
			CASE 10
				RechteckXOR x1%, y1%, xAlt%, yAlt%, 0
				RechteckXOR x1%, y1%, x%, y%, 0
			CASE 12
				' Mausgriffchen werden gerade gezogen
				GOSUB BerechneTransformation
				ZeichneMausgriffchen xMinA%, yMinA%, xMaxA%, yMaxA%
				FOR i% = aLi% TO zl% - 1
					ZeichneLinie li(i%), 0
				NEXT i%
				FOR i% = aRe% TO zr% - 1
					ZeichneRechteck re(i%), 0
				NEXT i%
				FOR i% = aKr% TO zk% - 1
					ZeichneKreis kr(i%), 0
				NEXT i%
				zl% = aLi%
				FOR i% = 0 TO aLi% - 1
					IF li(i%).gew THEN
						TransformiereLinie li(i%), li(zl%)
						ZeichneLinie li(zl%), -1
						zl% = zl% + 1
					END IF
				NEXT i%
				zr% = aRe%
				FOR i% = 0 TO aRe% - 1
					IF re(i%).gew THEN
						TransformiereRechteck re(i%), re(zr%)
						ZeichneRechteck re(zr%), -1
						zr% = zr% + 1
					END IF
				NEXT i%
				zk% = aKr%
				FOR i% = 0 TO aKr% - 1
					IF kr(i%).gew THEN
						TransformiereKreis kr(i%), kr(zk%)
						ZeichneKreis kr(zk%), -1
						zk% = zk% + 1
					END IF
				NEXT i%
				ZeichneMausgriffchen xMin%, yMin%, xMax%, yMax%
				xMinA% = xMin%
				xMaxA% = xMax%
				yMinA% = yMin%
				yMaxA% = yMax%
			END SELECT
			dosIntEin.ax = 1
			CALL INTERRUPTX(&H33, dosIntEin, dosIntAus)
			xAlt% = x%: yAlt% = y%
		END IF
	END IF
	' Taste loslassen
	dosIntEin.ax = 6
	dosIntEin.bx = 0
	CALL INTERRUPTX(&H33, dosIntEin, dosIntAus)
	IF dosIntAus.bx > 0 AND ZiehMod% > 0 THEN
		x% = dosIntAus.cx
		y% = dosIntAus.dx
		dosIntEin.ax = 2
		CALL INTERRUPTX(&H33, dosIntEin, dosIntAus)
		SELECT CASE ZiehMod%
		CASE 1
			' Element fixieren
			ZeichneLinie li(aLi%), 0
			li(aLi%).x2 = x%
			li(aLi%).y2 = y%
			ZeichneLinie li(aLi%), -1
			aLi% = aLi% + 1
		CASE 2
			ZeichneRechteck re(aRe%), 0
			re(aRe%).x2 = x%
			re(aRe%).y2 = y%
			IF re(aRe%).x1 > re(aRe%).x2 THEN
				SWAP re(aRe%).x1, re(aRe%).x2
			END IF
			IF re(aRe%).y1 > re(aRe%).y2 THEN
				SWAP re(aRe%).y1, re(aRe%).y2
			END IF
			ZeichneRechteck re(aRe%), -1
			aRe% = aRe% + 1
		CASE 3
			ZeichneKreis kr(aKr%), 0
			kr(aKr%).xm = (x1% + x%) \ 2
			kr(aKr%).ym = (y1% + y%) \ 2
			kr(aKr%).rx = ABS(x% - x1%) \ 2
			kr(aKr%).ry = ABS(y% - y1%) \ 2
			ZeichneKreis kr(aKr%), -1
			aKr% = aKr% + 1
		CASE 10
			RechteckXOR x1%, y1%, xAlt%, yAlt%, 0
			x2% = x%
			y2% = y%
			IF x1% > x2% THEN
				SWAP x1%, x2%
			END IF
			IF y1% > y2% THEN
				SWAP y1%, y2%
			END IF
			' Status der Umschalttaste abfragen
			dosIntEin.ax = &H200
			CALL INTERRUPTX(&H16, dosIntEin, dosIntAus)
			Shift% = dosIntAus.ax AND 3
			xMin% = 1000
			yMin% = 1000
			xMax% = -1000
			yMax% = -1000
			FOR i% = 0 TO aLi% - 1
				xi% = li(i%).x1
				xa% = li(i%).x2
				IF xi% > xa% THEN
					SWAP xi%, xa%
				END IF
				yi% = li(i%).y1
				ya% = li(i%).y2
				IF yi% > ya% THEN
					SWAP yi%, ya%
				END IF
				inPick% = xi% >= x1% AND xa% <= x2% AND yi% >= y1% AND ya% <= y2%
				IF Shift% THEN  ' Dazuwhlen!
					li(i%).gew = li(i%).gew XOR inPick%
					IF inPick% THEN
						MarkiereGewaehltLinie li(i%)
					END IF
				ELSE
					IF li(i%).gew XOR inPick% THEN
						MarkiereGewaehltLinie li(i%)
					END IF
					li(i%).gew = inPick%
				END IF
				IF li(i%).gew THEN
					IF xi% < xMin% THEN
						xMin% = xi%
					END IF
					IF xa% > xMax% THEN
						xMax% = xa%
					END IF
					IF yi% < yMin% THEN
						yMin% = yi%
					END IF
					IF ya% > yMax% THEN
						yMax% = ya%
					END IF
				END IF
			NEXT i%
			FOR i% = 0 TO aRe% - 1
				inPick% = re(i%).x1 >= x1% AND re(i%).x2 <= x2% AND re(i%).y1 >= y1% AND re(i%).y2 <= y2%
				IF Shift% THEN  ' Dazuwhlen!
					re(i%).gew = re(i%).gew XOR inPick%
					IF inPick% THEN
						MarkiereGewaehltRechteck re(i%)
					END IF
				ELSE
					IF re(i%).gew XOR inPick% THEN
						MarkiereGewaehltRechteck re(i%)
					END IF
					re(i%).gew = inPick%
				END IF
				IF re(i%).gew THEN
					IF re(i%).x1 < xMin% THEN
						xMin% = re(i%).x1
					END IF
					IF re(i%).x2 > xMax% THEN
						xMax% = re(i%).x2
					END IF
					IF re(i%).y1 < yMin% THEN
						yMin% = re(i%).y1
					END IF
					IF re(i%).y2 > yMax% THEN
						yMax% = re(i%).y2
					END IF
				END IF
			NEXT i%
			FOR i% = 0 TO aKr% - 1
				xi% = kr(i%).xm - kr(i%).rx
				xa% = kr(i%).xm + kr(i%).rx
				yi% = kr(i%).ym - kr(i%).ry
				ya% = kr(i%).ym + kr(i%).ry
				inPick% = xi% >= x1% AND xa% <= x2% AND yi% >= y1% AND ya% <= y2%
				IF Shift% THEN  ' Dazuwhlen!
					kr(i%).gew = kr(i%).gew XOR inPick%
					IF inPick% THEN
						MarkiereGewaehltKreis kr(i%)
					END IF
				ELSE
					IF kr(i%).gew XOR inPick% THEN
						MarkiereGewaehltKreis kr(i%)
					END IF
					kr(i%).gew = inPick%
				END IF
				IF kr(i%).gew THEN
					IF xi% < xMin% THEN
						xMin% = xi%
					END IF
					IF xa% > xMax% THEN
						xMax% = xa%
					END IF
					IF yi% < yMin% THEN
						yMin% = yi%
					END IF
					IF ya% > yMax% THEN
						yMax% = ya%
					END IF
				END IF
			NEXT i%
			IF xMinA% < xMaxA% THEN
				ZeichneMausgriffchen xMinA%, yMinA%, xMaxA%, yMaxA%
			END IF
			IF xMin% < xMax% THEN
				ZeichneMausgriffchen xMin%, yMin%, xMax%, yMax%
			END IF
			xMinA% = xMin%
			yMinA% = yMin%
			xMaxA% = xMax%
			yMaxA% = yMax%
		CASE 12
			' Verschieben/Skalieren abschliessen
			GOSUB BerechneTransformation
			ZeichneMausgriffchen xMinA%, yMinA%, xMaxA%, yMaxA%
			FOR i% = aLi% TO zl% - 1
				ZeichneLinie li(i%), 0
			NEXT i%
			FOR i% = aRe% TO zr% - 1
				ZeichneRechteck re(i%), 0
			NEXT i%
			FOR i% = aKr% TO zk% - 1
				ZeichneKreis kr(i%), 0
			NEXT i%
			' Prfen, ob <Ctrl> gedrckt ist => in diesem Fall eine Kopie erstellen
			dosIntEin.ax = &H200
			CALL INTERRUPTX(&H16, dosIntEin, dosIntAus)
			CtrlGed% = dosIntAus.ax AND 4
			zl% = aLi%
			FOR i% = 0 TO aLi% - 1
				IF li(i%).gew THEN
					li(zl%) = li(i%)
					TransformiereLinie li(zl%), li(i%)
					ZeichneLinie li(i%), -1
					IF CtrlGed% THEN
						li(zl%).gew = 0
						ZeichneLinie li(zl%), -1
						zl% = zl% + 1
					END IF
				END IF
			NEXT i%
			zr% = aRe%
			FOR i% = 0 TO aRe% - 1
				IF re(i%).gew THEN
					re(zr%) = re(i%)
					TransformiereRechteck re(zr%), re(i%)
					ZeichneRechteck re(i%), -1
					IF CtrlGed% THEN
						re(zr%).gew = 0
						ZeichneRechteck re(zr%), -1
						zr% = zr% + 1
					END IF
				END IF
			NEXT i%
			zk% = aKr%
			FOR i% = 0 TO aKr% - 1
				IF kr(i%).gew THEN
					kr(zk%) = kr(i%)
					TransformiereKreis kr(zk%), kr(i%)
					ZeichneKreis kr(i%), -1
					IF CtrlGed% THEN
						kr(zk%).gew = 0
						ZeichneKreis kr(zk%), -1
						zk% = zk% + 1
					END IF
				END IF
			NEXT i%
			IF CtrlGed% THEN
				aLi% = zl%
				aRe% = zr%
				aKr% = zk%
			END IF
			ZeichneMausgriffchen xMin%, yMin%, xMax%, yMax%
			xMinA% = xMin%
			xMaxA% = xMax%
			yMinA% = yMin%
			yMaxA% = yMax%
		END SELECT
		ZiehMod% = 0
		dosIntEin.ax = 1
		CALL INTERRUPTX(&H33, dosIntEin, dosIntAus)
	END IF
	t$ = INKEY$
	SELECT CASE t$
	CASE CHR$(0) + "S"
		' <Del> = wie in CorelDRAW! gewhlte Objekte lschen
		LoescheAuswahl 0
		i% = 0
		WHILE i% < aLi%
			IF li(i%).gew THEN
				ZeichneLinie li(i%), 0
				aLi% = aLi% - 1
				li(i%) = li(aLi%)
			ELSE
				i% = i% + 1
			END IF
		WEND
		i% = 0
		WHILE i% < aRe%
			IF re(i%).gew THEN
				ZeichneRechteck re(i%), 0
				aRe% = aRe% - 1
				re(i%) = re(aRe%)
			ELSE
				i% = i% + 1
			END IF
		WEND
		i% = 0
		WHILE i% < aKr%
			IF kr(i%).gew THEN
				ZeichneKreis kr(i%), 0
				aKr% = aKr% - 1
				kr(i%) = kr(aKr%)
			ELSE
				i% = i% + 1
			END IF
		WEND
		xMin% = 1000
		xMax% = -1000
		xMinA% = 1000
		xMaxA% = -1000
	CASE CHR$(27)
		Drinbleib% = 0
	END SELECT
WEND
dosIntEin.ax = 2
CALL INTERRUPTX(&H33, dosIntEin, dosIntAus)
END

BerechneTransformation:
IF NurSchieb% OR tLi% THEN
	xMin% = x% - xDr%
ELSE
	xMin% = xMinB%
END IF
IF NurSchieb% OR tRe% THEN
	xMax% = x% - xDr% - xMinB% + xMaxB%
ELSE
	xMax% = xMaxB%
END IF
IF NurSchieb% OR tOb% THEN
	yMin% = y% - yDr%
ELSE
	yMin% = yMinB%
END IF
IF NurSchieb% OR tUn% THEN
	yMax% = y% - yDr% - yMinB% + yMaxB%
ELSE
	yMax% = yMaxB%
END IF
xFakt! = CSNG(xMax% - xMin%) / CSNG(xMaxB% - xMinB%)
xTr! = CSNG(xMin%) - CSNG(xMinB%) * xFakt!
yFakt! = CSNG(yMax% - yMin%) / CSNG(yMaxB% - yMinB%)
yTr! = CSNG(yMin%) - CSNG(yMinB%) * yFakt!
RETURN

SUB LoescheAuswahl (f%)
	IF xMin% < xMax% THEN
		ZeichneMausgriffchen xMin%, yMin%, xMax%, yMax%
	END IF
	IF f% THEN
		xMinA% = 1000
		yMinA% = 1000
		xMaxA% = -1000
		yMaxA% = -1000
		xMin% = 1000
		yMin% = 1000
		xMax% = -1000
		yMax% = -1000
	END IF
	FOR i% = 0 TO aLi% - 1
		IF li(i%).gew THEN
			MarkiereGewaehltLinie li(i%)
			IF f% THEN
				li(i%).gew = 0
			END IF
		END IF
	NEXT i%
	FOR i% = 0 TO aRe% - 1
		IF re(i%).gew THEN
			MarkiereGewaehltRechteck re(i%)
			IF f% THEN
				re(i%).gew = 0
			END IF
		END IF
	NEXT i%
	FOR i% = 0 TO aKr% - 1
		IF kr(i%).gew THEN
			MarkiereGewaehltKreis kr(i%)
			IF f% THEN
				kr(i%).gew = 0
			END IF
		END IF
	NEXT i%
END SUB

SUB MarkiereGewaehltKreis (k AS Kreis)
	x% = k.xm - k.rx
	RechteckXOR x% - 2, k.ym - 2, x% + 2, k.ym + 2, 0
END SUB

SUB MarkiereGewaehltLinie (l AS Linie)
	RechteckXOR l.x1 - 2, l.y1 - 2, l.x1 + 2, l.y1 + 2, 0
END SUB

SUB MarkiereGewaehltRechteck (r AS Rechteck)
	RechteckXOR r.x1 - 2, r.y2 - 2, r.x1 + 2, r.y2 + 2, 0
END SUB

SUB MarkiereMenu (i%, t%)
	IF t% THEN
		COLOR 14
	ELSE
		COLOR 0
	END IF
	LINE (557, 13 + 32 * i%)-STEP(69, 21), , B
END SUB

SUB NeuzeichAlles
	COLOR 7
	CLS
	RESTORE MPunkte
	FOR i% = 0 TO 12
		LOCATE 2 + 2 * i%, 71
		IF i% < 6 THEN
			READ t$
			PRINT t$;
		ELSE
			COLOR i% + 3
			PRINT STRING$(8, 219);
		END IF
		LINE (556, 12 + 32 * i%)-STEP(71, 23), 7, B
	NEXT i%
	MarkiereMenu Fkt%, -1
	MarkiereMenu Farbe% - 3, -1
	FOR i% = 0 TO aLi% - 1
		ZeichneLinie li(i%), -1
	NEXT i%
	FOR i% = 0 TO aRe% - 1
		ZeichneRechteck re(i%), -1
	NEXT i%
	FOR i% = 0 TO aKr% - 1
		ZeichneKreis kr(i%), -1
	NEXT i%
	IF xMax% >= xMin% THEN
		ZeichneMausgriffchen xMin%, yMin%, xMax%, yMax%
	END IF
END SUB

SUB RechteckXOR (x1%, y1%, x2%, y2%, f%)
	IF x2% > x1% THEN
		x1a% = x1%
		x2a% = x2%
	ELSE
		x1a% = x2%
		x2a% = x1%
	END IF
	IF y2% > y1% THEN
		y1a% = y1%
		y2a% = y2%
	ELSE
		y1a% = y2%
		y2a% = y1%
	END IF
	IF x2a% - x1a% < 2 OR y2a% - y1a% < 2 OR f% THEN
		xorLin%(0) = x2a% - x1a% + 1
		xorLin%(1) = y2a% - y1a% + 1
		PUT (x1a%, y1a%), xorLin%, XOR
	ELSE
		xorLin%(0) = x2a% - x1a% + 1
		xorLin%(1) = 1
		PUT (x1a%, y1a%), xorLin%, XOR
		PUT (x1a%, y2a%), xorLin%, XOR
		y1a% = y1a% + 1
		xorLin%(0) = 1
		xorLin%(1) = y2a% - y1a%
		PUT (x1a%, y1a%), xorLin%, XOR
		PUT (x2a%, y1a%), xorLin%, XOR
	END IF
END SUB

SUB TransformiereKreis (kAlt AS Kreis, kNeu AS Kreis)
	kNeu.xm = CINT(CSNG(kAlt.xm) * xFakt! + xTr!)
	kNeu.ym = CINT(CSNG(kAlt.ym) * yFakt! + yTr!)
	kNeu.rx = CINT(ABS(CSNG(kAlt.rx) * xFakt!))
	kNeu.ry = CINT(ABS(CSNG(kAlt.ry) * yFakt!))
END SUB

SUB TransformiereLinie (lAlt AS Linie, lNeu AS Linie)
	lNeu.x1 = CINT(CSNG(lAlt.x1) * xFakt! + xTr!)
	lNeu.y1 = CINT(CSNG(lAlt.y1) * yFakt! + yTr!)
	lNeu.x2 = CINT(CSNG(lAlt.x2) * xFakt! + xTr!)
	lNeu.y2 = CINT(CSNG(lAlt.y2) * yFakt! + yTr!)
END SUB

SUB TransformiereRechteck (rAlt AS Rechteck, rNeu AS Rechteck)
	rNeu.x1 = CINT(CSNG(rAlt.x1) * xFakt! + xTr!)
	rNeu.y1 = CINT(CSNG(rAlt.y1) * yFakt! + yTr!)
	rNeu.x2 = CINT(CSNG(rAlt.x2) * xFakt! + xTr!)
	rNeu.y2 = CINT(CSNG(rAlt.y2) * yFakt! + yTr!)
END SUB

SUB ZeichneKreis (k AS Kreis, f%)
	IF f% THEN
		fa% = k.fa
	ELSE
		fa% = 0
	END IF
	IF k.rx = 0 THEN
		LINE (k.xm, k.ym - k.ry)-(k.xm, k.ym + k.ry), fa%
	ELSEIF k.ry = 0 THEN
		LINE (k.xm - k.rx, k.ym)-(k.xm + k.rx, k.ym), fa%
	ELSE
		IF k.ry > k.rx THEN
			r% = k.ry%
		ELSE
			r% = k.rx%
		END IF
		CIRCLE (k.xm, k.ym), r%, fa%, , , CSNG(k.ry) / CSNG(k.rx)
	END IF
	IF k.gew AND f% THEN
		MarkiereGewaehltKreis k
	END IF
END SUB

SUB ZeichneLinie (l AS Linie, f%)
	IF f% THEN
		fa% = l.fa
	ELSE
		fa% = 0
	END IF
	LINE (l.x1, l.y1)-(l.x2, l.y2), fa%
	IF l.gew AND f% THEN
		MarkiereGewaehltLinie l
	END IF
END SUB

SUB ZeichneMausgriffchen (x1%, y1%, x2%, y2%)
	RechteckXOR x1%, y1%, x2%, y2%, 0
	RechteckXOR x1% + 1, y1% + 1, x1% + 4, y1% + 4, -1
	RechteckXOR x2% - 1, y1% + 1, x2% - 4, y1% + 4, -1
	RechteckXOR x1% + 1, y2% - 1, x1% + 4, y2% - 4, -1
	RechteckXOR x2% - 1, y2% - 1, x2% - 4, y2% - 4, -1
	xm% = (x1% + x2% + 1) \ 2
	ym% = (y1% + y2% + 1) \ 2
	RechteckXOR xm% - 2, y1% + 1, xm% + 1, y1% + 4, -1
	RechteckXOR xm% - 2, y2% - 1, xm% + 1, y2% - 4, -1
	RechteckXOR x1% + 1, ym% - 2, x1% + 4, ym% + 1, -1
	RechteckXOR x2% - 1, ym% - 2, x2% - 4, ym% + 1, -1
END SUB

SUB ZeichneRechteck (r AS Rechteck, f%)
	IF f% THEN
		fa% = r.fa
	ELSE
		fa% = 0
	END IF
	LINE (r.x1, r.y1)-(r.x2, r.y2), fa%, B
	IF r.gew AND f% THEN
		MarkiereGewaehltRechteck r
	END IF
END SUB

